darcs

Issue 2282 Attemping to pull from a rebase-in-progress repo shows patch which should never been seen.

Title Attemping to pull from a rebase-in-progress repo shows patch which should never been seen.
Priority Status resolved
Milestone 2.10.0 HEAD Resolved in 2.10.0 HEAD
Superseder Nosy List ganesh, markstos
Assigned To ganesh
Topics Rebase

Created on 2012-12-17.20:52:44 by markstos, last changed 2013-02-16.14:43:30 by noreply.

Messages
msg16428 (view) Author: markstos Date: 2012-12-17.20:52:42
1. Summarise the issue (what were doing, what went wrong?)

I have seen The Patch Which Should Not Be Seen.

I was attempting to pull from a hashed repo in the "rebase-in-progress" 
state. It failed as follows:

###
$ darcs pull -p  10967  ../alpha-without-10782.bak
HINT: if you want to change the default remote repository to
      /home/mark/www/alpha-without-10782.bak,
      quit now and issue the same command with the --set-default flag.
darcs: failed to read patch:
Fri Dec 14 10:35:47 EST 2012  Invalid <invalid@invalid>
  * DO NOT TOUCH: Rebase patch
  This patch is an internal implementation detail of rebase, used to
  store suspended patches, and should not be visible in the user
  interface. Please report a bug if a darcs command is showing you this
  patch.
Couldn't parse file /home/mark/www/alpha-without-
10782/_darcs/patches/0000000344-
3eca5d03afe4e683ef311ad9987d3dce76b260ce7baa8b4657f1336c4e037ffc
which is patch
Fri Dec 14 10:35:47 EST 2012  Invalid <invalid@invalid>
  * DO NOT TOUCH: Rebase patch
  This patch is an internal implementation detail of rebase, used to
  store suspended patches, and should not be visible in the user
  interface. Please report a bug if a darcs command is showing you this
  patch.

2. What behaviour were you expecting instead?

I expected darcs to succeed or fail, not blow up. 

3. What darcs version are you using? (Try: darcs --exact-version)

 2.9.6 (+ 24 patches)

4. What operating system are you running?
 
Ubuntu Linux.  10.04 on EC2.
msg16429 (view) Author: markstos Date: 2012-12-17.20:54:00
Curiously, when I do "darcs show repo" on the "rebasing" repo, it reports 
that nothing is suspended:

Rebase in progress: 0 suspended patches
Rebase in progress: 0 suspended patches

Does that even make sense?
msg16430 (view) Author: markstos Date: 2012-12-17.20:56:21
I confirmed that repo is "stuck" in the rebasing state, with nothing to 
unsuspend:

###

$ darcs rebase unsuspend
No patches selected!

###

Thankfully, this was an "extra" copy of a repo , so I don't need to fix 
it.

No, I don't know steps we took to end up with a repo in this state.
msg16526 (view) Author: bf Date: 2013-01-08.12:22:49
I can confirm this. Ran into the same problem but didn't have the time
to make a useful report back then. I was not able to repair the repo,
not even by making a fresh copy with darcs get. In the end I had to
delete the rebased version and start anew w/o rebase. I think this was
with darcs-2.9.5 + ~ 36 patches but I could be wrong.
msg16529 (view) Author: ganesh Date: 2013-01-08.23:08:44
Apologies for the inconvenience to all: this should be easy to fix but I 
just haven't got round to it yet.

The easiest way to get out of the state once you're in it is to record a 
dummy patch, suspend and unsuspend that.
msg16626 (view) Author: ganesh Date: 2013-02-16.13:46:52
This should be fixed in screened now: patch1034
msg16637 (view) Author: noreply Date: 2013-02-16.14:43:29
The following patch sent by Ganesh Sittampalam <ganesh@earth.li> updated issue issue2282 with
status=resolved;resolvedin=2.10.0 HEAD

* resolve issue2282: don't allow remote operations to copy the rebase patch 
Ignore-this: 426064878381bbee4c030dc6b03ff7bb
History
Date User Action Args
2012-12-17 20:52:44markstoscreate
2012-12-17 20:54:01markstossetmessages: + msg16429
2012-12-17 20:56:23markstossetmessages: + msg16430
2013-01-08 12:17:16bfsetmessages: + msg16525
2013-01-08 12:18:44bfsetmessages: - msg16525
2013-01-08 12:22:49bfsetmessages: + msg16526
2013-01-08 23:08:46ganeshsetstatus: unknown -> needs-implementation
assignedto: ganesh
messages: + msg16529
nosy: + ganesh
milestone: 2.10.0 HEAD
2013-02-16 13:46:53ganeshsetmessages: + msg16626
2013-02-16 14:43:30noreplysetstatus: needs-implementation -> resolved
messages: + msg16637
resolvedin: 2.10.0 HEAD